#include "global.h"


void InitReports(void) {
    short int i;
    char sortorder[URLSIZE];
    
    
    /* Clear temporary directory */
    SArm("%s/*", cfg.TmpDir);
    
    /* TT_UNS: open */
    for (i = 0; i < TTNUMBER; i++) if (cfg.TTR[i]) {
    	SAsnprintf(TT[i].fname, sizeof(TT[i].fname), TEMPL_TT_UNS, cfg.TmpDir, icfg.TTRname[i]);
	TT[i].file = SAfopenI("w", TT[i].fname);
	TT[i].count = 0;
    }

    /* Replace localisation strings */
    if (LogFormats[cfg.LogFormat].Class == MAIL) {
	loc->User = loc->Sender;
	loc->Connections = loc->Messages;
	loc->URL = loc->Recipient;
	loc->Users = loc->Senders;
	loc->TopUser = loc->Senders;
	loc->TopSites = loc->Recipients;
	loc->TT[2] = loc->RecRejected;
	loc->TT[3] = loc->DelRejected;
    }

    /* Fill reports sorting description, so we will not do this many times for UFR, UR, UDR and TTR */
    SAsnprintf(sortorder, sizeof(sortorder), "%s, %s (%s, %s)", loc->URL, loc->DnT, loc->Asc, loc->Asc);
    rcfg.UFRsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s (%s)", loc->Bytes, loc->Desc);
    rcfg.URsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s (%s)", loc->DsT, loc->Asc);
    rcfg.UDRsort = SAstrdup(sortorder);
    SAsnprintf(sortorder, sizeof(sortorder), "%s, %s (%s, %s)", loc->User, loc->DnT, loc->Desc, loc->Asc);
    rcfg.TTRsort = SAstrdup(sortorder);

    /* Clear efficiency data */
    if (cfg.PER) memset(ec, 0, sizeof(ec));
}


void GenerateReports(void) {
    short int i, j;
    char tfname[FILENAMESIZE];
    FILE *DF;


    /* Create reports directory */
    j = SAsnprintf(tfname, sizeof(tfname), "%s/%s-", cfg.TargetDir, icfg.Period);
    FixFileName(&tfname[j - strlen(icfg.Period)]);
    
    for (i = 1; ; i++) {
	SAsnprintf(&tfname[j], sizeof(tfname) - j, "%hd", i);
	if (mkdir(tfname, 0755)) {
	    if (errno != EEXIST) SAexit("%s. %s", tfname, strerror(errno));
	} else break;
    }
    
    /* Save reports directory */
    icfg.ReportDir = SAstrdup(tfname);

    ReportTypical();
    ReportTopUser();
    if (cfg.UR || cfg.TSR) ReportUsers();
    if (cfg.ER != NULL) ReportEmail();
    if (cfg.TSR) ReportTopSites();
    if (cfg.PER) ReportProxyEfficiency();
    ReportList();

    /* DF: all */
    DF = SAfopen("w", "%s/%s", icfg.ReportDir, icfg.DFname);
    SAfprintf(DF, "%ld %ld\n%s\n%.0f\n%d\n", icfg.SDate, icfg.EDate, cfg.Name, all[0].Bytes, ccueCount);
    SAfclose(DF, icfg.DFname);

    ReportIndex();
}
